﻿#
# garminlauncher Version 2 Version: 2.5
#
# a simple script to launch garmin mobile xt with different settings 
# written on Nokia N78 by hthede@gmx.de (see http://hthede.de)
#
# logging by help from http://wiki.forum.nokia.com/index.php/How_to_read_GPS_data
#
# version 2009-09-14: backup/restore *.nvm's; logging
#
import appuifw, e32, os, positioning, time, sys

# other variable, dont edit until you know what you do!
# old ProfileList = [u"zuFuss", u"AutoAnsicht", u"Auto", u"Auto unbef", u"Haenger"]
ProfileList = [u"Auto", u"Fahrrad", u"Fussgaenger", u"Outdoor"]
gmxtconf=u"E:\\Garmin\\Apps\\Symbian\\GARMIN.NVM"
conffile=u"E:\\Garmin\\gmxtlaunch.ini"
mapfile=u"E:\\Garmin\\gmapsupp.img"
path=u"E:\\Garmin\\Apps\\Symbian\\"
backuppath=u"E:\\Garmin\\_backup\\"
profileprefix=u"E:\\Garmin\\Apps\\Symbian\\profile-"
profile="x"
backupfiles=["GARMIN.NVM", "GARMIN_ARTE.NVM", "GARMIN_ATRK.NVM", "GARMIN_FLASH.NVM", "GARMIN_MPM.NVM", "GARMIN_SRTE.NVM", "GARMIN_STRANSIT.NVM", "GARMIN_STRK.NVM", "GARMIN_WPT.NVM", "gmobile.ini"]
zeit=time.strftime("%Y%m%d-%H%M%S")
logdir=u"E:\\gmxt_log"
logfile=logdir+"\\"+zeit+".log"
delay=5
log=1
remap=0
profilefile=""
mapfileprof=""
mapfiledef=""
mapfiletmp=""
Profiles=""
profilenr=0
useconf=0

# function: gmxt start
def gmxt():
    try:
        print u"gmxt start"

        if log == 1:
            # with logging enabled without waiting
            e32.start_exe(u"e:\\sys\\bin\\GMobileXT.exe", "")
            e32.ao_sleep(10)
        else:
            # without logging we can wait for finished gmxt
            e32.start_exe(u"e:\\sys\\bin\\GMobileXT.exe", "",1)
        
    except:
        print u"!!> cant start GMobileXT.exe"

# read config
def readconfig():
    global log, ProfileList, Profiles, delay, useconf
  
    try:
        conf = file (conffile)
        useconf=1
        print u">found extern config"
    except:
        useconf=0
        print u">no extern config"

    if useconf == 1:
        while True:
            line = conf.readline()
            if len(line) == 0: 
                break

            line=line.replace(" ","")
            line=line.replace("\n","")
            line=line.partition("=")
                

            if line[0] == "profiles":
                    ProfileList=line[2].split(",")

                    for profilename in ProfileList:

                        if profilename.find("=") != -1:
                            profilename=profilename.partition("=")
                            profilename=profilename[0]
                            profilename=profilename.replace(" ","")
                            Profiles=Profiles+","+profilename
                        else:
                            Profiles=Profiles+","+profilename

                    Profiles=Profiles.replace(",","",1)
                    Profiles=unicode(Profiles)
                    Profiles=Profiles.split(",")

            if line[0] == "log":
                log = line[2]
                log = float(log)

            if line[0] == "delay":
                delay = line[2]
                delay = float(delay)


# function: copy profile to setting
def prof2conf():
    global remap, profilefile, mapfileprof, mapfiletmp, mapfiledef

    profilefile=profileprefix+profile
    mapfiletmp=mapfile+"-tmp"   
    mapfiledef=mapfile+"-def"

    profilename=ProfileList[profilenr]

    if profilename.find("=") != -1:
        remap=1
        mapfileprof=profilename.partition("=")
        mapfileprof=profilename[1]
        mapfileprof=mapfileprof.replace(" ","")
    else:
        remap=0

    # copy conf
    try:
        e32.file_copy(gmxtconf, profilefile)
        print u"> take profilefile "+profile
    except:
        print u"!!> cant copy "+profilefile+" to "+gmxtconf+"; take old conf instead"
    
    # test gmapsupp-x for rename
    if remap == 1:
        try:
            os.rename(mapfileprof, mapfiletmp)
            remap=1
            print u"> take gmapsupp "+profile
        except:
            remap=0
            print u"> no special gmapsupp"
    
    # rename default map to def-tmp
    if remap == 1:
        try:
            os.rename(mapfile, mapfiledef)
        except:
            remap=0
            print u"> no default gmapsupp here or cannot rename it"
    
    # prof-tmp to mapfile
    if remap == 1:
        try:
            os.rename(mapfiletmp, mapfile)
        except:
            remap=0
            print u"> Error while renaming gmapsupp for profile, cancel renaming"

# function: copy setting back to profile
def conf2prof():
    global remap, profilefile, mapfileprof, mapfiletmp, mapfiledef

    try:
        e32.file_copy(profilefile, gmxtconf)
        print u"> write back profilefile "+profile
    except:
        print u"!!> cant copy "+gmxtconf+" to "+profilefile
        
    # special map zurcksetzen
    if remap == 1:
        try:
            os.rename(mapfile, mapfileprof)
        except:
            remap=0
            print u"> Error while renaming gmapsupp back to profile, cancel renaming"
        
    # default map zurcksetzen
    if remap == 1:
        try:
            os.rename(mapfiledef, mapfile)
        except:
            remap=0
            print u"> no default gmapsupp here or cannot rename back"
            

# function: backup
def backup():
    try:
      os.mkdir(backuppath)
    except:
      print u"ok, backuppath here"
    
    print u"make backup..."
    print u"copy current.gpx"
    conffile=u"E:\\Garmin\\GPX\\current.gpx"
    backupfile=backuppath+"current.gpx"
    try:
        e32.file_copy(backupfile, conffile)
    except:
        print u">cant copy "+ conffile
    
    for item in backupfiles:
        conffile=path+item
        backupfile=backuppath+item

        try:
          e32.file_copy(backupfile, conffile)
          print u"copy "+item
        except:
          print u">cant copy "+ item

    print u"backup ready"
      
      
    
# function: restore
def restore():
  print u"> try to restore old settings from "+backuppath
  
  try:
    print u"restore current.gpx"
    conffile=u"E:\\Garmin\\GPX\\current.gpx"
    backupfile=backuppath+"current.gpx" 
    e32.file_copy(conffile, backupfile)
  
    for item in backupfiles:
      conffile=path+item
      backupfile=backuppath+item  
      print u"restore "+item
      e32.file_copy(conffile, backupfile)
    else:
      print u"restore ready, please restart "
  except:
    print u"cannot restore one or more files"

# gps functions 
def gps_init():
    #This function will start the updating of global variable (dictionary) 'gps_data' every 0.2 sec.
    #0.2 sec comes form 'interval = 200000' set according to your needs
    #This function uses callback funtion gps
    global gps_data, log
    #First this fills the gps_data with 0.0 so that there is something before the first gps update
    gps_data = {
    'satellites': {'horizontal_dop': 0.0, 'used_satellites': 0, 'vertical_dop': 0.0, 'time': 0.0,'satellites': 0, 'time_dop':0.0}, 
    'position': {'latitude': 0.0, 'altitude': 0.0, 'vertical_accuracy': 0.0, 'longitude': 0.0, 'horizontal_accuracy': 0.0}, 
    'course': {'speed': 0.0, 'heading': 0.0, 'heading_accuracy': 0.0, 'speed_accuracy': 0.0}
    }
    try:
        positioning.select_module(positioning.default_module())
        positioning.set_requestors([{"type":"service","format":"application","data":"gps_app"}])
        positioning.position(course=1,satellites=1,callback=gps, interval=200000,partial=0)
        e32.ao_sleep(3)
        print u"GPS connectet, will log"
    except:
        log=0
        print u"NO LOGGING: Problem with GPS"
        
def gps(event):
    global gps_data
    gps_data = event
 
def gps_stop():
    #This function stops GPS
    try:
        positioning.stop_position()
    except:
        print u"Problem with GPS"

# logger
def logger():
  sats = gps_data['satellites']['satellites']
  usats = gps_data['satellites']['used_satellites']

  if usats != 0:  
    sattime = gps_data['satellites']['time']
    pos_lat = gps_data['position']['latitude']
    pos_long = gps_data['position']['longitude']
    pos_alt = gps_data['position']['altitude']
    logline = str(sattime)+";"+str(pos_lat)+";"+str(pos_long)+";"+str(pos_alt)+"\n"
    print u"FIX: ", usats, sats, sattime
    datei.write(logline)
  else:
    print u"NO FIX: see ", sats, u"sat's"
        
# capture red key
def exit_key_handler():
  # fuction for exit
  # save menu
  SL = [u"Exit", u"Save&Exit", u"Restore"]
  s = appuifw.popup_menu(SL)

  # exit
  if log == 1:
      print u"close logfile"
      datei.close()
      print u"close gps"
      gps_stop()

  if s == 0:
    backup()

  if s == 1:
    conf2prof()
    backup()
  
  if s == 2:
    restore()
    
  print u"exit gmxtlaunch"
  if log == 1:
      e32.ao_sleep(3)
      appuifw.app.set_exit()
  
##  the Popup and main
# read config
readconfig()

# init log
if log == 1:
    gps_init()
    
    try:
      os.mkdir(logdir)
    except:
      print u"ok, logdir always here"

    datei = open(logfile, "w")

    # capture red key
    appuifw.app.exit_key_handler = exit_key_handler

else:
    print u">Logging disabled in conf"

# start menu
if useconf == 1:
    p = appuifw.popup_menu(Profiles, u"Waehle Profil + OK:")
    profilenr=p
    profile=str(p)
else:
    p = appuifw.popup_menu(ProfileList, u"Waehle Profil + OK:")
    profilenr=p
    profile=str(p)
    

# copy conf and start gmxt
prof2conf()
gmxt()

# main
if log == 1:
    # loop for logger, exit via exit - button
    print(u"EXIT for exit!")

    while True:
        if log == 1:    
            logger()
            
        e32.ao_sleep(delay)
else:
    # no need for loop
    exit_key_handler()
    



